## glewlwyd 2.7.6+ds

=== CMakeLists.txt ===
#
# Glewlwyd
#
# CMake file used to build program
#
# Copyright 2016-2022 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the MIT License
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#

cmake_minimum_required(VERSION 3.5)

project(glewlwyd C)

set(CMAKE_C_STANDARD 99)
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Werror")

# library info

set(GLWD_LIBS )
set(SCHEME_MODULES )

set(PROGRAM_VERSION_MAJOR "2")
set(PROGRAM_VERSION_MINOR "7")
set(PROGRAM_VERSION_PATCH "6")
set(PROJECT_DESCRIPTION "Single Sign On server, OAuth2, Openid Connect, multiple factor authentication with, HOTP/TOTP, FIDO2, TLS Certificates, etc. extensible via plugins ")
set(PROJECT_BUGREPORT_PATH "https://github.com/babelouest/glewlwyd/issues")
set(LIBCBOR_VERSION_REQUIRED "0.5.0")
set(JANSSON_VERSION_REQUIRED "2.11")
set(ORCANIA_VERSION_REQUIRED "2.3.3")
set(YDER_VERSION_REQUIRED "1.4.20")
set(ULFIUS_VERSION_REQUIRED "2.7.15")
set(HOEL_VERSION_REQUIRED "1.4.29")
set(RHONABWY_VERSION_REQUIRED "1.1.13")
set(IDDAWC_VERSION_REQUIRED "1.1.9")

set(USER_MODULES_SRC_PATH "${CMAKE_CURRENT_SOURCE_DIR}/src/user/")
set(USER_MODULES )

set(USER_MIDDLEWARE_MODULES_SRC_PATH "${CMAKE_CURRENT_SOURCE_DIR}/src/user_middleware/")
set(USER_MIDDLEWARE_MODULES )

set(CLIENT_MODULES_SRC_PATH "${CMAKE_CURRENT_SOURCE_DIR}/src/client/")
set(CLIENT_MODULES )

set(SCHEME_MODULES_SRC_PATH "${CMAKE_CURRENT_SOURCE_DIR}/src/scheme/")
set(SCHEME_MODULES )

set(PLUGIN_MODULES_SRC_PATH "${CMAKE_CURRENT_SOURCE_DIR}/src/plugin/")
set(PLUGIN_MODULES )

set(RESOURCES_SRC_PATH "${CMAKE_CURRENT_SOURCE_DIR}/docs/resources/ulfius/")

include(GNUInstallDirs)
include(CheckSymbolExists)

# cmake modules

set(G_CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake-modules)
list(APPEND CMAKE_MODULE_PATH "${G_CMAKE_MODULE_PATH}")

# check if _GNU_SOURCE is available

if (NOT _GNU_SOURCE)
  check_symbol_exists(__GNU_LIBRARY__ "features.h" _GNU_SOURCE)

  if (NOT _GNU_SOURCE)
    unset(_GNU_SOURCE CACHE)
    check_symbol_exists(_GNU_SOURCE "features.h" _GNU_SOURCE)
  endif ()
endif ()

if (_GNU_SOURCE)
  add_definitions(-D_GNU_SOURCE)
endif ()

list(APPEND GLWD_LIBS "-ldl -lcrypt")

find_package(Threads REQUIRED)
list(APPEND GLWD_LIBS ${CMAKE_THREAD_LIBS_INIT})

include(FindJansson)
set(JANSSON_MIN_VERSION 2.4)
find_package(Jansson ${JANSSON_MIN_VERSION} REQUIRED)
list(APPEND GLWD_LIBS Jansson::Jansson)

include(FindNettle)
find_package(Nettle REQUIRED)
list(APPEND GLWD_LIBS Nettle::Nettle)

include(FindGnuTLS)
find_package(GnuTLS REQUIRED)
list(APPEND GLWD_LIBS GnuTLS::GnuTLS)

include(FindMHD)
find_package(MHD REQUIRED)
list(APPEND GLWD_LIBS MHD::MHD)

include(FindLibconfig)
find_package(Libconfig REQUIRED)
list(APPEND GLWD_LIBS LibConfig::LibConfig)

find_package(ZLIB REQUIRED)
list(APPEND GLWD_LIBS ZLIB::ZLIB)

# build

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src)
add_executable(glewlwyd ${CMAKE_CURRENT_SOURCE_DIR}/src/glewlwyd.h
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/glewlwyd-common.h
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/static_compressed_inmemory_website_callback.h
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/http_compression_callback.h
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/client.c
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/misc.c
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/module.c
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/plugin.c
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/scope.c
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/session.c
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/static_compressed_inmemory_website_callback.c
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/http_compression_callback.c
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/user.c
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/api_key.c
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/misc_config.c
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/metrics.c
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/webservice.c
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/glewlwyd.c )
set_target_properties(glewlwyd PROPERTIES COMPILE_OPTIONS "-Wextra;-Wconversion")

find_package(Orcania ${ORCANIA_VERSION_REQUIRED} REQUIRED)
if ("${ORCANIA_VERSION_STRING}" VERSION_GREATER_EQUAL "${ORCANIA_VERSION_REQUIRED}")
    message(STATUS "Orcania found: ${ORCANIA_VERSION_STRING}")
else ()
    message( FATAL_ERROR "Orcania version required: ${ORCANIA_VERSION_REQUIRED} - version installed: ${ORCANIA_VERSION_STRING}")
endif ()
list(APPEND GLWD_LIBS Orcania::Orcania)

find_package(Yder ${YDER_VERSION_REQUIRED} REQUIRED)
if ("${YDER_VERSION_STRING}" VERSION_GREATER_EQUAL "${YDER_VERSION_REQUIRED}")
    message(STATUS "Yder found: ${YDER_VERSION_STRING}")
else ()
    message( FATAL_ERROR "Yder version required: ${YDER_VERSION_REQUIRED} - version installed: ${YDER_VERSION_STRING}")
endif ()
list(APPEND GLWD_LIBS Yder::Yder)

find_package(Ulfius ${ULFIUS_VERSION_REQUIRED} REQUIRED)
if ("${ULFIUS_VERSION_STRING}" VERSION_GREATER_EQUAL "${ULFIUS_VERSION_REQUIRED}")
    message(STATUS "Ulfius found: ${ULFIUS_VERSION_STRING}")
else ()
    message( FATAL_ERROR "Ulfius version required: ${ULFIUS_VERSION_REQUIRED} - version installed: ${ULFIUS_VERSION_STRING}")
endif ()
list(APPEND GLWD_LIBS Ulfius::Ulfius)

find_package(Hoel ${HOEL_VERSION_REQUIRED} REQUIRED)
if ("${HOEL_VERSION_STRING}" VERSION_GREATER_EQUAL "${HOEL_VERSION_REQUIRED}")
    message(STATUS "Hoel found: ${HOEL_VERSION_STRING}")
else ()
    message( FATAL_ERROR "Hoel version required: ${HOEL_VERSION_REQUIRED} - version installed: ${HOEL_VERSION_STRING}")
endif ()
list(APPEND GLWD_LIBS Hoel::Hoel)

target_link_libraries(glewlwyd ${GLWD_LIBS})

set(CPACK_DEBIAN_PACKAGE_DEPENDS "libc6 (>= 2.3.4)")

execute_process(COMMAND lsb_release -is
    OUTPUT_VARIABLE DISTRIB_CODENAME_T
    OUTPUT_STRIP_TRAILING_WHITESPACE
)
string( TOLOWER "${DISTRIB_CODENAME_T}" DISTRIB_CODENAME )

execute_process(COMMAND lsb_release -cs
    OUTPUT_VARIABLE RELEASE_CODENAME_T
    OUTPUT_STRIP_TRAILING_WHITESPACE
)
string( TOLOWER "${RELEASE_CODENAME_T}" RELEASE_CODENAME )

option(WITH_MOCK "Build Mock modules" off)

# user modules

if (WITH_MOCK OR BUILD_GLEWLWYD_TESTING)
  set(MOCK_LIB_SRC ${CMAKE_CURRENT_SOURCE_DIR}/src/glewlwyd-common.h ${CMAKE_CURRENT_SOURCE_DIR}/src/misc.c ${USER_MODULES_SRC_PATH}/mock.c)

  add_library(usermodmock MODULE ${MOCK_LIB_SRC})
  set_target_properties(usermodmock PROPERTIES
      COMPILE_OPTIONS "-Wextra;-Wconversion"
      LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/user")
  target_link_libraries(usermodmock ${GLWD_LIBS})
  list(APPEND USER_MODULES usermodmock)
endif ()

option(WITH_USER_DATABASE "Build Database backend user module" on)
if (WITH_USER_DATABASE)
  set(LIB_SRC ${CMAKE_CURRENT_SOURCE_DIR}/src/glewlwyd-common.h ${CMAKE_CURRENT_SOURCE_DIR}/src/misc.c ${USER_MODULES_SRC_PATH}/database.c)

  add_library(usermoddatabase MODULE ${LIB_SRC})
  set_target_properties(usermoddatabase PROPERTIES
      COMPILE_OPTIONS "-Wextra;-Wconversion"
      LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/user")
  target_link_libraries(usermoddatabase ${GLWD_LIBS})
  list(APPEND USER_MODULES usermoddatabase)
endif ()

option(WITH_USER_LDAP "Build LDAP backend user module" on)
if (WITH_USER_LDAP)
  include(FindLdap)
  find_package(Ldap REQUIRED)
  if (LDAP_FOUND)
    include_directories(${LDAP_INCLUDE_DIRS})
  endif ()
  set(LIB_SRC ${CMAKE_CURRENT_SOURCE_DIR}/src/glewlwyd-common.h ${CMAKE_CURRENT_SOURCE_DIR}/src/misc.c ${USER_MODULES_SRC_PATH}/ldap.c)
  if ("${DISTRIB_CODENAME}" STREQUAL "ubuntu" AND "${RELEASE_CODENAME}" STREQUAL "impish")
    set(CPACK_DEBIAN_PACKAGE_DEPENDS "${CPACK_DEBIAN_PACKAGE_DEPENDS}, libldap-2.5-0")
  elseif ("${DISTRIB_CODENAME}" STREQUAL "ubuntu" AND "${RELEASE_CODENAME}" STREQUAL "jammy")
    set(CPACK_DEBIAN_PACKAGE_DEPENDS "${CPACK_DEBIAN_PACKAGE_DEPENDS}, libldap-2.5-0")
  elseif ("${DISTRIB_CODENAME}" STREQUAL "ubuntu" AND "${RELEASE_CODENAME}" STREQUAL "kinetic")
    set(CPACK_DEBIAN_PACKAGE_DEPENDS "${CPACK_DEBIAN_PACKAGE_DEPENDS}, libldap-2.5-0")
  elseif ("${DISTRIB_CODENAME}" STREQUAL "ubuntu" AND "${RELEASE_CODENAME}" STREQUAL "lunar")
    set(CPACK_DEBIAN_PACKAGE_DEPENDS "${CPACK_DEBIAN_PACKAGE_DEPENDS}, libldap2")
  elseif ("${DISTRIB_CODENAME}" STREQUAL "ubuntu" AND "${RELEASE_CODENAME}" STREQUAL "mantic")
    set(CPACK_DEBIAN_PACKAGE_DEPENDS "${CPACK_DEBIAN_PACKAGE_DEPENDS}, libldap2")
  elseif ("${DISTRIB_CODENAME}" STREQUAL "debian" AND "${RELEASE_CODENAME}" STREQUAL "bookworm")
    set(CPACK_DEBIAN_PACKAGE_DEPENDS "${CPACK_DEBIAN_PACKAGE_DEPENDS}, libldap-2.5-0")
  elseif ("${DISTRIB_CODENAME}" STREQUAL "debian" AND "${RELEASE_CODENAME}" STREQUAL "trixie")
    set(CPACK_DEBIAN_PACKAGE_DEPENDS "${CPACK_DEBIAN_PACKAGE_DEPENDS}, libldap-2.5-0")
  else ()
    set(CPACK_DEBIAN_PACKAGE_DEPENDS "${CPACK_DEBIAN_PACKAGE_DEPENDS}, libldap-2.4-2")
  endif ()

  add_library(usermodldap MODULE ${LIB_SRC})
  set_target_properties(usermodldap PROPERTIES
      COMPILE_OPTIONS "-Wextra;-Wconversion"
      LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/user")
  target_link_libraries(usermodldap ${GLWD_LIBS} OpenLDAP::OpenLDAP "-llber")
  list(APPEND USER_MODULES usermodldap)
endif ()

option(WITH_USER_HTTP "Build HTTP backend user module" on)
if (WITH_USER_HTTP)
  set(LIB_SRC ${CMAKE_CURRENT_SOURCE_DIR}/src/glewlwyd-common.h ${CMAKE_CURRENT_SOURCE_DIR}/src/misc.c ${USER_MODULES_SRC_PATH}/http.c)

  add_library(usermodhttp MODULE ${LIB_SRC})
  set_target_properties(usermodhttp PROPERTIES
      COMPILE_OPTIONS "-Wextra;-Wconversion"
      LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/user")
  target_link_libraries(usermodhttp ${GLWD_LIBS})
  list(APPEND USER_MODULES usermodhttp)
endif ()

# user middleware modules

if (WITH_MOCK OR BUILD_GLEWLWYD_TESTING)
  set(MOCK_LIB_SRC ${CMAKE_CURRENT_SOURCE_DIR}/src/glewlwyd-common.h ${CMAKE_CURRENT_SOURCE_DIR}/src/misc.c ${USER_MIDDLEWARE_MODULES_SRC_PATH}/mock.c)

  add_library(usermidmodmock MODULE ${MOCK_LIB_SRC})
  set_target_properties(usermidmodmock PROPERTIES
      COMPILE_OPTIONS "-Wextra;-Wconversion"
      LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/user_middleware")
  target_link_libraries(usermidmodmock ${GLWD_LIBS})
  set(USER_MIDDLEWARE_MODULES ${USER_MIDDLEWARE_MODULES} usermidmodmock)
endif ()

# clients modules

if (WITH_MOCK OR BUILD_GLEWLWYD_TESTING)
  set(MOCK_LIB_SRC ${CMAKE_CURRENT_SOURCE_DIR}/src/glewlwyd-common.h ${CMAKE_CURRENT_SOURCE_DIR}/src/misc.c ${CLIENT_MODULES_SRC_PATH}/mock.c)

  add_library(clientmodmock MODULE ${MOCK_LIB_SRC})
  set_target_properties(clientmodmock PROPERTIES
      COMPILE_OPTIONS "-Wextra;-Wconversion"
      LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/client")
  target_link_libraries(clientmodmock ${GLWD_LIBS})
  set(CLIENT_MODULES ${CLIENT_MODULES} clientmodmock)
endif ()

option(WITH_CLIENT_DATABASE "Build Database backend client module" on)
if (WITH_CLIENT_DATABASE)
  set(LIB_SRC ${CMAKE_CURRENT_SOURCE_DIR}/src/glewlwyd-common.h ${CMAKE_CURRENT_SOURCE_DIR}/src/misc.c ${CLIENT_MODULES_SRC_PATH}/database.c)

  add_library(clientmoddatabase MODULE ${LIB_SRC})
  set_target_properties(clientmoddatabase PROPERTIES
      COMPILE_OPTIONS "-Wextra;-Wconversion"
      LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/client")
  target_link_libraries(clientmoddatabase ${GLWD_LIBS})
  list(APPEND CLIENT_MODULES clientmoddatabase)
endif ()

option(WITH_CLIENT_LDAP "Build LDAP backend client module" on)
if (WITH_CLIENT_LDAP)
  include(FindLdap)
  find_package(Ldap REQUIRED)
  if (LDAP_FOUND)
    include_directories(${LDAP_INCLUDE_DIRS})
  endif ()

=== Makefile ===
#
# Glewlwyd OAuth2 Authorization Server
#
# Makefile used to build the software
#
# Copyright 2016-2019 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU GENERAL PUBLIC LICENSE
# License as published by the Free Software Foundation;
# version 3 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU GENERAL PUBLIC LICENSE for more details.
#
# You should have received a copy of the GNU General Public
# License along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

GLEWLWYD_SOURCE=./src
GLEWLWYD_TESTS=./test
GLEWLWYD_DOCS=./docs
GLEWLWYD_DOCKER=./docs/docker
all:
	cd $(GLEWLWYD_SOURCE) && $(MAKE) $*

debug:
	cd $(GLEWLWYD_SOURCE) && $(MAKE) debug $*

install:
	cd $(GLEWLWYD_SOURCE) && $(MAKE) install $*

memcheck:
	cd $(GLEWLWYD_SOURCE) && $(MAKE) memcheck $*

test-debug:
	cd $(GLEWLWYD_SOURCE) && $(MAKE) test-debug $*

check:
	cd $(GLEWLWYD_TESTS) && $(MAKE) test $*

clean:
	cd $(GLEWLWYD_SOURCE) && $(MAKE) clean
	cd $(GLEWLWYD_TESTS) && $(MAKE) clean
	cd $(GLEWLWYD_DOCKER) && $(MAKE) clean
	docker rmi -f babelouest/glewlwyd:src babelouest/glewlwyd:ci
	docker system prune -f

docs/docker/orcania.tar.gz:
	wget https://github.com/babelouest/orcania/archive/refs/heads/master.tar.gz -O docs/docker/orcania.tar.gz

docs/docker/yder.tar.gz:
	wget https://github.com/babelouest/yder/archive/refs/heads/master.tar.gz -O docs/docker/yder.tar.gz

docs/docker/ulfius.tar.gz:
	wget https://github.com/babelouest/ulfius/archive/refs/heads/master.tar.gz -O docs/docker/ulfius.tar.gz

docs/docker/hoel.tar.gz:
	wget https://github.com/babelouest/hoel/archive/refs/heads/master.tar.gz -O docs/docker/hoel.tar.gz

docs/docker/rhonabwy.tar.gz:
	wget https://github.com/babelouest/rhonabwy/archive/refs/heads/master.tar.gz -O docs/docker/rhonabwy.tar.gz

docs/docker/iddawc.tar.gz:
	wget https://github.com/babelouest/iddawc/archive/refs/heads/master.tar.gz -O docs/docker/iddawc.tar.gz

docker: docs/docker/orcania.tar.gz docs/docker/yder.tar.gz docs/docker/ulfius.tar.gz docs/docker/hoel.tar.gz docs/docker/rhonabwy.tar.gz docs/docker/iddawc.tar.gz
	docker build --file=Dockerfile -t babelouest/glewlwyd:src .

docker-run:
	docker run --rm -it -p 4593:4593 babelouest/glewlwyd:src

docker-ci: docs/docker/orcania.tar.gz docs/docker/yder.tar.gz docs/docker/ulfius.tar.gz docs/docker/hoel.tar.gz docs/docker/rhonabwy.tar.gz docs/docker/iddawc.tar.gz 
	docker build --file=Dockerfile-ci -t babelouest/glewlwyd:ci .

docker-ci-run:
	docker run --rm -it -p 4593:4593 babelouest/glewlwyd:ci

manpage:
	cd $(GLEWLWYD_SOURCE) && $(MAKE) $*
	help2man $(GLEWLWYD_SOURCE)/glewlwyd -s 8 -n "Single-Sign-On (SSO) server with multiple factor authentication" > $(GLEWLWYD_DOCS)/glewlwyd.8

=== src/Makefile ===
#
# Glewlwyd SSO Server
#
# Makefile used to build the software
#
# Copyright 2016-2021 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU GENERAL PUBLIC LICENSE
# License as published by the Free Software Foundation;
# version 3 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU GENERAL PUBLIC LICENSE for more details.
#
# You should have received a copy of the GNU General Public
# License along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

CC=gcc
CFLAGS+=-c -Wall -Werror -Wextra -Wconversion -D_REENTRANT $(shell pkg-config --cflags liborcania) $(shell pkg-config --cflags libyder) $(shell pkg-config --cflags libulfius) $(shell pkg-config --cflags jansson) $(shell pkg-config --cflags libhoel) $(shell pkg-config --cflags gnutls) $(shell pkg-config --cflags libconfig) $(shell pkg-config --cflags nettle) $(shell pkg-config --cflags hogweed) $(ADDITIONALFLAGS)
LIBS=$(shell pkg-config --libs liborcania) $(shell pkg-config --libs libyder) $(shell pkg-config --libs libulfius) $(shell pkg-config --libs libhoel) $(shell pkg-config --libs jansson) $(shell pkg-config --libs gnutls) $(shell pkg-config --libs libconfig) $(shell pkg-config --libs nettle) $(shell pkg-config --libs hogweed) -ldl -lpthread -lcrypt -lz
OBJECTS=glewlwyd.o misc.o webservice.o session.o user.o scope.o plugin.o client.o module.o api_key.o misc_config.o metrics.o static_compressed_inmemory_website_callback.o http_compression_callback.o
DESTDIR=/usr/local
CONFIG_FILE=../glewlwyd.conf

all: release

clean:
	rm -f *.o glewlwyd valgrind.txt
	cd user && $(MAKE) clean
	cd user_middleware && $(MAKE) clean
	cd client && $(MAKE) clean
	cd scheme && $(MAKE) clean
	cd plugin && $(MAKE) clean

debug: ADDITIONALFLAGS=-Wunreachable-code -DDEBUG -g -O0

debug: glewlwyd
	cd user && $(MAKE) debug
	cd user_middleware && $(MAKE) debug
	cd client && $(MAKE) debug
	cd scheme && $(MAKE) debug
	cd plugin && $(MAKE) debug

release: ADDITIONALFLAGS=-O3

release: glewlwyd
	cd user && $(MAKE)
	cd user_middleware && $(MAKE)
	cd client && $(MAKE)
	cd scheme && $(MAKE)
	cd plugin && $(MAKE)

%.o: %.c glewlwyd.h glewlwyd-common.h static_compressed_inmemory_website_callback.h http_compression_callback.h
	$(CC) $(CFLAGS) $(CPPFLAGS) $<

glewlwyd: $(OBJECTS)
	$(CC) -o $@ $^ $(LIBS) $(LDFLAGS)

memcheck: debug
	valgrind --tool=memcheck --leak-check=full --show-leak-kinds=all --track-origins=yes ./glewlwyd --config-file $(CONFIG_FILE) 2>valgrind.txt

test-debug: debug
	./glewlwyd --config-file $(CONFIG_FILE) -e

install: glewlwyd
	install glewlwyd $(DESTDIR)/bin
	cd user && $(MAKE) install DESTDIR=$(DESTDIR)
	cd user_middleware && $(MAKE) install DESTDIR=$(DESTDIR)
	cd client && $(MAKE) install DESTDIR=$(DESTDIR)
	cd scheme && $(MAKE) install DESTDIR=$(DESTDIR)
	cd plugin && $(MAKE) install DESTDIR=$(DESTDIR)

=== test/Makefile ===
#
# Glewlwyd SSO
#
# Makefile used to build the tests
#
# Public domain, no copyright. Use at your own risk.
#

CC=gcc
CFLAGS=-Wall -D_REENTRANT -DDEBUG -g -O0
LDFLAGS=-lc $(shell pkg-config --libs liborcania) $(shell pkg-config --libs libyder) $(shell pkg-config --libs libulfius) $(shell pkg-config --libs libhoel) $(shell pkg-config --libs librhonabwy) $(shell pkg-config --libs libiddawc) $(shell pkg-config --libs jansson) $(shell pkg-config --libs check) $(shell pkg-config --libs gnutls) $(shell pkg-config --libs liboath) $(shell pkg-config --libs libcbor) -lpthread -lcbor
TARGET_ADMIN=glewlwyd_admin_mod_type glewlwyd_admin_mod_user glewlwyd_admin_mod_user_auth_scheme glewlwyd_admin_mod_client glewlwyd_admin_mod_plugin glewlwyd_admin_check_scope glewlwyd_admin_api_key glewlwyd_admin_mod_user_middleware
TARGET_AUTH=glewlwyd_auth_password glewlwyd_auth_scheme glewlwyd_auth_grant glewlwyd_auth_check_scheme glewlwyd_auth_scheme_trigger glewlwyd_auth_scheme_register glewlwyd_auth_profile glewlwyd_auth_session_manage glewlwyd_auth_profile_get_scheme_available glewlwyd_auth_profile_impersonate glewlwyd_scheme_forbidden glewlwyd_mail_on_connection glewlwyd_mail_on_scheme_register glewlwyd_mail_on_update_password
TARGET_CRUD=glewlwyd_crud_user glewlwyd_crud_client glewlwyd_crud_scope glewlwyd_crud_user_middleware glewlwyd_crud_misc_config
TARGET_OAUTH2=glewlwyd_oauth2_auth_code glewlwyd_oauth2_code glewlwyd_oauth2_code_client_confidential glewlwyd_oauth2_implicit glewlwyd_oauth2_resource_owner_pwd_cred glewlwyd_oauth2_resource_owner_pwd_cred_client_confidential glewlwyd_oauth2_client_cred glewlwyd_oauth2_refresh_token glewlwyd_oauth2_refresh_token_client_confidential glewlwyd_oauth2_delete_token glewlwyd_oauth2_delete_token_client_confidential glewlwyd_oauth2_profile glewlwyd_oauth2_refresh_manage_session glewlwyd_oauth2_profile_impersonate glewlwyd_oauth2_additional_parameters glewlwyd_oauth2_client_secret glewlwyd_oauth2_code_challenge glewlwyd_oauth2_token_introspection glewlwyd_oauth2_token_revocation glewlwyd_oauth2_device_authorization glewlwyd_oauth2_code_replay glewlwyd_oauth2_scheme_required
TARGET_OIDC=glewlwyd_oidc_auth_code glewlwyd_oidc_code glewlwyd_oidc_code_client_confidential glewlwyd_oidc_token glewlwyd_oidc_resource_owner_pwd_cred glewlwyd_oidc_resource_owner_pwd_cred_client_confidential glewlwyd_oidc_client_cred glewlwyd_oidc_code_idtoken glewlwyd_oidc_implicit_id_token_token glewlwyd_oidc_implicit_none glewlwyd_oidc_hybrid_id_token_token_code glewlwyd_oidc_hybrid_id_token_code glewlwyd_oidc_hybrid_token_code glewlwyd_oidc_implicit_id_token glewlwyd_oidc_optional_request_parameters glewlwyd_oidc_refresh_token glewlwyd_oidc_refresh_token_client_confidential glewlwyd_oidc_delete_token glewlwyd_oidc_delete_token_client_confidential glewlwyd_oidc_refresh_manage_session glewlwyd_oidc_profile_impersonate glewlwyd_oidc_userinfo glewlwyd_oidc_additional_parameters glewlwyd_oidc_only_no_refresh glewlwyd_oidc_discovery glewlwyd_oidc_client_secret glewlwyd_oidc_request_jwt glewlwyd_oidc_subject_type glewlwyd_oidc_address_claim glewlwyd_oidc_claims_scopes glewlwyd_oidc_claim_request glewlwyd_oidc_code_challenge glewlwyd_oidc_token_introspection glewlwyd_oidc_token_revocation glewlwyd_oidc_client_registration glewlwyd_oidc_jwt_encrypted glewlwyd_oidc_jwks_config glewlwyd_oidc_session_management glewlwyd_oidc_device_authorization glewlwyd_oidc_refresh_token_one_use glewlwyd_oidc_client_registration_management glewlwyd_oidc_code_replay glewlwyd_oidc_scheme_required glewlwyd_oidc_dpop glewlwyd_oidc_resource glewlwyd_oidc_rich_auth_requests glewlwyd_oidc_pushed_auth_requests glewlwyd_oidc_reduced_scope glewlwyd_oidc_all_algs glewlwyd_oidc_ciba glewlwyd_oidc_auth_iss_is glewlwyd_oidc_jarm glewlwyd_oidc_fapi
TARGET_REGISTER=glewlwyd_register
TARGET_IRL=glewlwyd_mod_user_irl glewlwyd_mod_client_irl glewlwyd_mod_user_multiple_password_irl glewlwyd_mod_user_http glewlwyd_oauth2_irl glewlwyd_oidc_irl glewlwyd_scheme_mail glewlwyd_scheme_otp glewlwyd_scheme_webauthn glewlwyd_scheme_retype_password glewlwyd_scheme_http glewlwyd_scheme_oauth2 glewlwyd_geolocation iddawc_resource_tester
TARGET_CERTIFICATE=glewlwyd_scheme_certificate glewlwyd_oidc_client_certificate
TARGET_PROFILE_DELETE=glewlwyd_profile_delete
TARGET_PROMETHEUS=glewlwyd_prometheus
TARGET_SINGLE_USER_SESSION=glewlwyd_auth_single_user_session
VERBOSE=0
MEMCHECK=0
RUN=1
PARAM_FILE=param.json
VALGRIND_COMMAND=valgrind --tool=memcheck --leak-check=full --show-leak-kinds=all
CERT=cert
RESOURCES_ULFIUS=../docs/resources/ulfius/

all: test $(CERT)/server.key

clean:
	rm -f *.o *.log valgrind.txt valgrind-*.txt $(TARGET_ADMIN) $(TARGET_AUTH) $(TARGET_CRUD) $(TARGET_OAUTH2) $(TARGET_OIDC) $(TARGET_IRL) $(TARGET_CERTIFICATE) $(TARGET_REGISTER) $(TARGET_PROFILE_DELETE) $(TARGET_PROMETHEUS) $(TARGET_SINGLE_USER_SESSION)
	rm -f $(CERT)/server.* $(CERT)/root* $(CERT)/client* $(CERT)/user* $(CERT)/packed* $(CERT)/apple* $(CERT)/certtool.log

$(CERT)/server.key:
	./$(CERT)/create-cert.sh

build: $(TARGET_ADMIN) $(TARGET_AUTH) $(TARGET_CRUD) $(TARGET_OAUTH2) $(TARGET_OIDC) $(TARGET_IRL) $(TARGET_CERTIFICATE) $(TARGET_REGISTER) $(TARGET_PROFILE_DELETE) $(TARGET_PROMETHEUS) $(TARGET_SINGLE_USER_SESSION) $(CERT)/server.key

iddawc_resource.o: $(RESOURCES_ULFIUS)/iddawc_resource.c $(RESOURCES_ULFIUS)/iddawc_resource.h
	$(CC) -c $(CFLAGS) -I$(RESOURCES_ULFIUS) $(CPPFLAGS) $(RESOURCES_ULFIUS)/iddawc_resource.c

iddawc_resource_tester: iddawc_resource_tester.c iddawc_resource.o unit-tests.o
	$(CC) $(CFLAGS) -I$(RESOURCES_ULFIUS) iddawc_resource.o unit-tests.o iddawc_resource_tester.c -o iddawc_resource_tester $(LDFLAGS)

unit-tests.o: unit-tests.c unit-tests.h
	$(CC) $(CFLAGS) -c unit-tests.c

%: %.c unit-tests.o
	$(CC) $(CFLAGS) $^ -o $@ $(LDFLAGS)

test: build test-admin test-auth test-crud test-oauth2 test-oidc test-irl test-register test-profile-delete

test-auth: $(TARGET_AUTH) test_glewlwyd_auth_password test_glewlwyd_auth_scheme test_glewlwyd_auth_grant test_glewlwyd_auth_check_scheme test_glewlwyd_auth_scheme_trigger test_glewlwyd_auth_scheme_register test_glewlwyd_auth_profile test_glewlwyd_auth_session_manage test_glewlwyd_auth_profile_get_scheme_available test_glewlwyd_auth_profile_impersonate test_glewlwyd_scheme_forbidden test_glewlwyd_mail_on_connection test_glewlwyd_mail_on_scheme_register test_glewlwyd_mail_on_update_password

test-admin: $(TARGET_ADMIN) test_glewlwyd_admin_mod_type test_glewlwyd_admin_mod_user test_glewlwyd_admin_mod_user_auth_scheme test_glewlwyd_admin_mod_client test_glewlwyd_admin_mod_plugin test_glewlwyd_admin_check_scope test_glewlwyd_admin_api_key test_glewlwyd_admin_mod_user_middleware

test-crud: $(TARGET_CRUD) test_glewlwyd_crud_user test_glewlwyd_crud_client test_glewlwyd_crud_scope test_glewlwyd_crud_user_middleware test_glewlwyd_crud_misc_config

test-oauth2: $(TARGET_OAUTH2) test_glewlwyd_oauth2_auth_code test_glewlwyd_oauth2_code test_glewlwyd_oauth2_code_client_confidential test_glewlwyd_oauth2_implicit test_glewlwyd_oauth2_resource_owner_pwd_cred test_glewlwyd_oauth2_resource_owner_pwd_cred_client_confidential test_glewlwyd_oauth2_client_cred test_glewlwyd_oauth2_refresh_token test_glewlwyd_oauth2_refresh_token_client_confidential test_glewlwyd_oauth2_delete_token test_glewlwyd_oauth2_delete_token_client_confidential test_glewlwyd_oauth2_profile test_glewlwyd_oauth2_refresh_manage_session test_glewlwyd_oauth2_profile_impersonate test_glewlwyd_oauth2_additional_parameters test_glewlwyd_oauth2_client_secret test_glewlwyd_oauth2_code_challenge test_glewlwyd_oauth2_token_introspection test_glewlwyd_oauth2_token_revocation test_glewlwyd_oauth2_device_authorization test_glewlwyd_oauth2_code_replay test_glewlwyd_oauth2_scheme_required

test-oidc: $(TARGET_OIDC) $(CERT)/server.key test_glewlwyd_oidc_auth_code test_glewlwyd_oidc_code test_glewlwyd_oidc_code_client_confidential test_glewlwyd_oidc_token test_glewlwyd_oidc_resource_owner_pwd_cred test_glewlwyd_oidc_resource_owner_pwd_cred_client_confidential test_glewlwyd_oidc_client_cred test_glewlwyd_oidc_code_idtoken test_glewlwyd_oidc_implicit_id_token_token test_glewlwyd_oidc_implicit_id_token test_glewlwyd_oidc_implicit_none test_glewlwyd_oidc_hybrid_id_token_token_code test_glewlwyd_oidc_hybrid_token_code test_glewlwyd_oidc_hybrid_id_token_code test_glewlwyd_oidc_optional_request_parameters test_glewlwyd_oidc_refresh_token test_glewlwyd_oidc_refresh_token_client_confidential test_glewlwyd_oidc_delete_token test_glewlwyd_oidc_delete_token_client_confidential test_glewlwyd_oidc_refresh_manage_session test_glewlwyd_oidc_profile_impersonate test_glewlwyd_oidc_userinfo test_glewlwyd_oidc_additional_parameters test_glewlwyd_oidc_only_no_refresh test_glewlwyd_oidc_discovery test_glewlwyd_oidc_client_secret test_glewlwyd_oidc_request_jwt test_glewlwyd_oidc_subject_type test_glewlwyd_oidc_address_claim test_glewlwyd_oidc_claims_scopes test_glewlwyd_oidc_claim_request test_glewlwyd_oidc_code_challenge test_glewlwyd_oidc_token_introspection test_glewlwyd_oidc_token_revocation test_glewlwyd_oidc_client_registration test_glewlwyd_oidc_jwt_encrypted test_glewlwyd_oidc_jwks_config test_glewlwyd_oidc_session_management test_glewlwyd_oidc_device_authorization test_glewlwyd_oidc_refresh_token_one_use test_glewlwyd_oidc_client_registration_management test_glewlwyd_oidc_code_replay test_glewlwyd_oidc_scheme_required test_glewlwyd_oidc_dpop test_glewlwyd_oidc_resource test_glewlwyd_oidc_rich_auth_requests test_glewlwyd_oidc_pushed_auth_requests test_glewlwyd_oidc_reduced_scope test_glewlwyd_oidc_all_algs test_glewlwyd_oidc_ciba test_glewlwyd_oidc_auth_iss_is test_glewlwyd_oidc_jarm test_glewlwyd_oidc_fapi

test-certificate: $(TARGET_CERTIFICATE) $(CERT)/server.key test_glewlwyd_scheme_certificate test_glewlwyd_oidc_client_certificate

test-register: $(TARGET_REGISTER) $(CERT)/server.key test_glewlwyd_register

test-profile-delete: $(TARGET_PROFILE_DELETE) test_glewlwyd_profile_delete

test-prometheus: $(TARGET_PROMETHEUS) test_glewlwyd_prometheus

test-single-user-session: $(TARGET_SINGLE_USER_SESSION) test_glewlwyd_auth_single_user_session

test-irl: $(TARGET_IRL) $(CERT)/server.key test_glewlwyd_mod_user_http test_glewlwyd_scheme_http test_glewlwyd_scheme_mail test_glewlwyd_scheme_otp test_glewlwyd_scheme_webauthn test_glewlwyd_scheme_retype_password test_glewlwyd_scheme_oauth2 test_glewlwyd_geolocation test_iddawc_resource_tester
	@for JSON_FILE in mod_user_*.json; \
		do $(MAKE) test_glewlwyd_mod_user_irl PARAM_FILE=$$JSON_FILE $*; \
	done
	@for JSON_FILE in mod_multiple_password_*.json; \
		do $(MAKE) test_glewlwyd_mod_user_multiple_password_irl PARAM_FILE=$$JSON_FILE $*; \
	done
	@for JSON_FILE in mod_client_*.json; \
		do $(MAKE) test_glewlwyd_mod_client_irl PARAM_FILE=$$JSON_FILE $*; \
	done
	@for JSON_FILE in plugin_oauth2_*.json; \
		do $(MAKE) test_glewlwyd_oauth2_irl PARAM_FILE=$$JSON_FILE $*; \
	done
	@for JSON_FILE in plugin_oidc_*.json; \
		do $(MAKE) test_glewlwyd_oidc_irl PARAM_FILE=$$JSON_FILE $*; \
	done

test_%_irl: %_irl
	@if [ "$(VERBOSE)" = "0" ] && [ "$(MEMCHECK)" = "0" ]; then \
		echo "Run $^ with file $(PARAM_FILE)"; \
		LD_LIBRARY_PATH=. ./run_test.sh ./$^ $(PARAM_FILE); \
		mv $^.log $^-$(PARAM_FILE).log; \
	elif [ "$(MEMCHECK)" = "0" ]; then \
		LD_LIBRARY_PATH=. ./$^ $(PARAM_FILE); \
	else \
		CK_FORK=no LD_LIBRARY_PATH=. $(VALGRIND_COMMAND) ./$^ $(PARAM_FILE) 2>valgrind-$@.txt; \
	fi

test_%: %
	@if [ "$(VERBOSE)" = "0" ] && [ "$(MEMCHECK)" = "0" ]; then \
		LD_LIBRARY_PATH=. ./run_test.sh ./$^ $(PARAM); \
	elif [ "$(MEMCHECK)" = "0" ]; then \
		LD_LIBRARY_PATH=. ./$^ $(PARAM); \
	else \
		CK_FORK=no LD_LIBRARY_PATH=. $(VALGRIND_COMMAND) ./$^ $(PARAM) 2>valgrind-$@.txt; \
	fi

=== docs/docker/Makefile ===
GLEWLWYD_VERSION=$(shell curl -s https://api.github.com/repos/babelouest/glewlwyd/releases/latest | grep tag_name | cut -d '"' -f 4 | cut -c 2-)

ORCANIA_GLEWLWYD_CMAKE_VERSION=$(shell grep ORCANIA_VERSION CMakeLists-latest.txt | head -n 1 | cut -c 31- | sed 's/\".*//')
YDER_GLEWLWYD_CMAKE_VERSION=$(shell grep YDER_VERSION CMakeLists-latest.txt | head -n 1 | cut -c 28- | sed 's/\".*//')
ULFIUS_GLEWLWYD_CMAKE_VERSION=$(shell grep ULFIUS_VERSION CMakeLists-latest.txt | head -n 1 | cut -c 30- | sed 's/\".*//')
HOEL_GLEWLWYD_CMAKE_VERSION=$(shell grep HOEL_VERSION CMakeLists-latest.txt | head -n 1 | cut -c 28- | sed 's/\".*//')
RHONABWY_GLEWLWYD_CMAKE_VERSION=$(shell grep RHONABWY_VERSION CMakeLists-latest.txt | head -n 1 | cut -c 32- | sed 's/\".*//')
IDDAWC_GLEWLWYD_CMAKE_VERSION=$(shell grep IDDAWC_VERSION CMakeLists-latest.txt | head -n 1 | cut -c 30- | sed 's/\".*//')

all: build

CMakeLists-latest.txt:
	wget https://github.com/babelouest/glewlwyd/raw/v$(GLEWLWYD_VERSION)/CMakeLists.txt -O CMakeLists-latest.txt

orcania.tar.gz: CMakeLists-latest.txt
	wget https://github.com/babelouest/orcania/archive/refs/tags/v$(ORCANIA_GLEWLWYD_CMAKE_VERSION).tar.gz -O orcania.tar.gz

yder.tar.gz: CMakeLists-latest.txt
	wget https://github.com/babelouest/yder/archive/refs/tags/v$(YDER_GLEWLWYD_CMAKE_VERSION).tar.gz -O yder.tar.gz

ulfius.tar.gz: CMakeLists-latest.txt
	wget https://github.com/babelouest/ulfius/archive/refs/tags/v$(ULFIUS_GLEWLWYD_CMAKE_VERSION).tar.gz -O ulfius.tar.gz

hoel.tar.gz: CMakeLists-latest.txt
	wget https://github.com/babelouest/hoel/archive/refs/tags/v$(HOEL_GLEWLWYD_CMAKE_VERSION).tar.gz -O hoel.tar.gz

rhonabwy.tar.gz: CMakeLists-latest.txt
	wget https://github.com/babelouest/rhonabwy/archive/refs/tags/v$(RHONABWY_GLEWLWYD_CMAKE_VERSION).tar.gz -O rhonabwy.tar.gz

iddawc.tar.gz: CMakeLists-latest.txt
	wget https://github.com/babelouest/iddawc/archive/refs/tags/v$(IDDAWC_GLEWLWYD_CMAKE_VERSION).tar.gz -O iddawc.tar.gz

glewlwyd.tar.gz: CMakeLists-latest.txt
	wget https://github.com/babelouest/glewlwyd/archive/refs/tags/v$(GLEWLWYD_VERSION).tar.gz -O glewlwyd.tar.gz

build: orcania.tar.gz yder.tar.gz ulfius.tar.gz hoel.tar.gz rhonabwy.tar.gz iddawc.tar.gz glewlwyd.tar.gz
	docker build -t babelouest/glewlwyd:$(GLEWLWYD_VERSION) .
	docker tag babelouest/glewlwyd:$(GLEWLWYD_VERSION) babelouest/glewlwyd:latest

run:
	docker run --rm -it -p 4593:4593 babelouest/glewlwyd:latest

my-config:
	docker run --rm -it -p 4593:4593 -v $(shell pwd)/config:/etc/glewlwyd babelouest/glewlwyd

clean:
	rm -f orcania.tar.gz yder.tar.gz ulfius.tar.gz hoel.tar.gz rhonabwy.tar.gz iddawc.tar.gz glewlwyd.tar.gz CMakeLists-latest.txt
	docker rmi -f babelouest/glewlwyd:latest babelouest/glewlwyd:$(GLEWLWYD_VERSION)
	docker system prune -f

=== src/client/Makefile ===
#
# Glewlwyd client backend
#
# Makefile used to build the software
#
# Copyright 2016-2019 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation;
# version 2.1 of the License.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
# GNU GENERAL PUBLIC LICENSE for more details.
#
# You should have received a copy of the GNU General Public
# License along with this library.	If not, see <http://www.gnu.org/licenses/>.
#

GLWD_SRC=..
DESTDIR=/usr/local
MODULES_TARGET=$(DESTDIR)/lib/glewlwyd/client
CC=gcc
CFLAGS+=-c -fPIC -Wall -Werror -Wextra -Wconversion -Wno-unknown-pragmas -D_REENTRANT -Wno-pragmas -I$(GLWD_SRC) $(shell pkg-config --cflags liborcania) $(shell pkg-config --cflags libyder) $(shell pkg-config --cflags jansson) $(shell pkg-config --cflags libhoel) $(ADDITIONALFLAGS)
LIBS=$(shell pkg-config --libs liborcania) $(shell pkg-config --libs libyder) $(shell pkg-config --libs jansson) -ldl
TARGET=libmoddatabase.so libmodldap.so

all: release

%.o: %.c ../glewlwyd-common.h
	$(CC) $(CFLAGS) $(CPPFLAGS) $<

misc.o: $(GLWD_SRC)/misc.c $(GLWD_SRC)/glewlwyd-common.h
	$(CC) $(CFLAGS) $(CPPFLAGS) $(GLWD_SRC)/misc.c

libmodmock.so: $(GLWD_SRC)/glewlwyd-common.h mock.o misc.o
	$(CC) -shared -Wl,-soname,libmodmock.so -o libmodmock.so mock.o misc.o $(LIBS)

libmoddatabase.so: $(GLWD_SRC)/glewlwyd-common.h database.o misc.o
	$(CC) -shared -Wl,-soname,libmoddatabase.so -o libmoddatabase.so database.o misc.o $(LIBS) $(shell pkg-config --libs libhoel)

libmodldap.so: $(GLWD_SRC)/glewlwyd-common.h ldap.o misc.o
	$(CC) -shared -Wl,-soname,libmodldap.so -o libmodldap.so ldap.o misc.o $(LIBS) -lldap -lcrypt

clean:
	rm -f *.o *.so

debug: ADDITIONALFLAGS=-DDEBUG -g -O0

debug: libmodmock.so $(TARGET)

release: ADDITIONALFLAGS=-O3

release: $(TARGET)

install:
	mkdir -p $(MODULES_TARGET)
	cp -f *.so $(MODULES_TARGET)

=== src/plugin/Makefile ===
#
# Glewlwyd potocol backend
#
# Makefile used to build the software
#
# Copyright 2016-2019 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation;
# version 2.1 of the License.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
# GNU GENERAL PUBLIC LICENSE for more details.
#
# You should have received a copy of the GNU General Public
# License along with this library.	If not, see <http://www.gnu.org/licenses/>.
#

RESOURCES_ULFIUS=../../docs/resources/ulfius
GLWD_SRC=..
DESTDIR=/usr/local
MODULES_TARGET=$(DESTDIR)/lib/glewlwyd/plugin
CC=gcc
CFLAGS+=-c -fPIC -Wall -Werror -Wextra -Wconversion -Wno-unknown-pragmas -D_REENTRANT -Wno-pragmas -I$(GLWD_SRC) -I$(RESOURCES_ULFIUS) $(shell pkg-config --cflags liborcania) $(shell pkg-config --cflags libyder) $(shell pkg-config --cflags jansson) $(shell pkg-config --cflags libhoel) $(shell pkg-config --cflags librhonabwy) $(shell pkg-config --cflags libiddawc) $(shell pkg-config --cflags gnutls) $(ADDITIONALFLAGS)
LIBS=$(shell pkg-config --libs liborcania) $(shell pkg-config --libs libyder) $(shell pkg-config --libs libulfius) $(shell pkg-config --libs libhoel) $(shell pkg-config --libs librhonabwy) $(shell pkg-config --libs libiddawc) $(shell pkg-config --libs jansson) -ldl
TARGET_RELEASE=libprotocol_oauth2.so libprotocol_oidc.so libprotocol_register.so
TARGET_DEBUG=libprotocol_mock.so

all: release

%.o: %.c ../glewlwyd-common.h
	$(CC) $(CFLAGS) $(CPPFLAGS) $<

misc.o: ../misc.c ../glewlwyd-common.h
	$(CC) $(CFLAGS) $(CPPFLAGS) ../misc.c

glewlwyd_resource.o: $(RESOURCES_ULFIUS)/glewlwyd_resource.c $(RESOURCES_ULFIUS)/glewlwyd_resource.h
	$(CC) $(CFLAGS) $(CPPFLAGS) $(RESOURCES_ULFIUS)/glewlwyd_resource.c

libprotocol_oauth2.so: protocol_oauth2.o misc.o glewlwyd_resource.o $(GLWD_SRC)/glewlwyd-common.h $(RESOURCES_ULFIUS)/glewlwyd_resource.h
	$(CC) -shared -Wl,-soname,libprotocol_oauth2.so -o libprotocol_oauth2.so protocol_oauth2.o misc.o glewlwyd_resource.o $(LIBS)

libprotocol_oidc.so: protocol_oidc.o misc.o $(GLWD_SRC)/glewlwyd-common.h
	$(CC) -shared -Wl,-soname,libprotocol_oidc.so -o libprotocol_oidc.so protocol_oidc.o misc.o $(LIBS) $(shell pkg-config --libs gnutls)

libprotocol_mock.so: mock.o misc.o $(GLWD_SRC)/glewlwyd-common.h
	$(CC) -shared -Wl,-soname,libprotocol_mock.so -o libprotocol_mock.so mock.o misc.o $(LIBS)

libprotocol_register.so: register.o misc.o $(GLWD_SRC)/glewlwyd-common.h
	$(CC) -shared -Wl,-soname,libprotocol_register.so -o libprotocol_register.so register.o misc.o $(LIBS)

clean:
	rm -f *.o *.so

debug: ADDITIONALFLAGS=-DDEBUG -g -O0

debug: $(TARGET_RELEASE) $(TARGET_DEBUG)

release: ADDITIONALFLAGS=-O3

release: $(TARGET_RELEASE)

install:
	mkdir -p $(MODULES_TARGET)
	cp -f *.so $(MODULES_TARGET)

=== src/scheme/Makefile ===
#
# Glewlwyd authentication scheme
#
# Makefile used to build the software
#
# Copyright 2016-2019 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation;
# version 2.1 of the License.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
# GNU GENERAL PUBLIC LICENSE for more details.
#
# You should have received a copy of the GNU General Public
# License along with this library.	If not, see <http://www.gnu.org/licenses/>.
#

GLWD_SRC=..
DESTDIR=/usr/local
MODULES_TARGET=$(DESTDIR)/lib/glewlwyd/scheme
CC=gcc
CFLAGS+=-c -fPIC -Wall -Werror -Wextra -Wconversion -Wno-unknown-pragmas -D_REENTRANT -Wno-pragmas -I$(GLWD_SRC) $(shell pkg-config --cflags liborcania) $(shell pkg-config --cflags libyder) $(shell pkg-config --cflags jansson) $(shell pkg-config --cflags libhoel) $(shell pkg-config --cflags librhonabwy) $(shell pkg-config --cflags libiddawc) $(shell pkg-config --cflags libcbor) $(ADDITIONALFLAGS)
LIBS=$(shell pkg-config --libs liborcania) $(shell pkg-config --libs libyder) $(shell pkg-config --libs libhoel) $(shell pkg-config --libs jansson) -ldl
TARGET=libmodemail.so libmodwebauthn.so libmodotp.so libmodpassword.so libmodcertificate.so libmodhttp.so libmodoauth2.so

all: release

%.o: %.c $(GLWD_SRC)/glewlwyd.h
	$(CC) $(CFLAGS) $(CPPFLAGS) $<

misc.o: $(GLWD_SRC)/misc.c $(GLWD_SRC)/glewlwyd-common.h
	$(CC) $(CFLAGS) $(CPPFLAGS) $(GLWD_SRC)/misc.c

libmodmock.so: mock.o misc.o
	$(CC) -shared -Wl,-soname,libmodmock.so -o libmodmock.so mock.o misc.o $(LIBS)

libmodemail.so: email.o misc.o
	$(CC) -shared -Wl,-soname,libmodemail.so -o libmodemail.so email.o misc.o $(LIBS)

libmodwebauthn.so: webauthn.o misc.o
	$(CC) -shared -Wl,-soname,libmodwebauthn.so -o libmodwebauthn.so webauthn.o misc.o $(LIBS) $(shell pkg-config --libs libcbor) $(shell pkg-config --libs librhonabwy) -lldap

libmodotp.so: otp.o misc.o
	$(CC) -shared -Wl,-soname,libmodotp.so -o libmodotp.so otp.o misc.o $(LIBS) $(shell pkg-config --libs liboath)

libmodpassword.so: password.o misc.o
	$(CC) -shared -Wl,-soname,libmodpassword.so -o libmodpassword.so password.o misc.o $(LIBS)

libmodcertificate.so: certificate.o misc.o
	$(CC) -shared -Wl,-soname,libmodcertificate.so -o libmodcertificate.so certificate.o misc.o $(LIBS)

libmodhttp.so: http.o misc.o
	$(CC) -shared -Wl,-soname,libmodhttp.so -o libmodhttp.so http.o misc.o $(LIBS)

libmodoauth2.so: oauth2.o misc.o
	$(CC) -shared -Wl,-soname,libmodoauth2.so -o libmodoauth2.so oauth2.o misc.o $(LIBS) $(shell pkg-config --libs libiddawc)

clean:
	rm -f *.o *.so

debug: ADDITIONALFLAGS=-DDEBUG -g -O0

debug: libmodmock.so $(TARGET)

release: ADDITIONALFLAGS=-O3

release: $(TARGET)

install:
	mkdir -p $(MODULES_TARGET)
	cp -f *.so $(MODULES_TARGET)

=== src/user_middleware/Makefile ===
#
# Glewlwyd user backend
#
# Makefile used to build the software
#
# Copyright 2016-2021 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation;
# version 2.1 of the License.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
# GNU GENERAL PUBLIC LICENSE for more details.
#
# You should have received a copy of the GNU General Public
# License along with this library.	If not, see <http://www.gnu.org/licenses/>.
#

GLWD_SRC=..
DESTDIR=/usr/local
MODULES_TARGET=$(DESTDIR)/lib/glewlwyd/user_middleware
CC=gcc
CFLAGS+=-c -fPIC -Wall -Werror -Wextra -Wconversion -Wno-unknown-pragmas -D_REENTRANT -Wno-pragmas -I$(GLWD_SRC) $(shell pkg-config --cflags liborcania) $(shell pkg-config --cflags libyder) $(shell pkg-config --cflags jansson) $(shell pkg-config --cflags libhoel) $(ADDITIONALFLAGS)
LIBS=$(shell pkg-config --libs liborcania) $(shell pkg-config --libs libyder) $(shell pkg-config --libs jansson) -ldl
LDFLAGS += -Wl,-R '-Wl,-R$$ORIGIN'
TARGET=
all: release

misc.o: $(GLWD_SRC)/misc.c $(GLWD_SRC)/glewlwyd-common.h
	$(CC) $(CFLAGS) $(CPPFLAGS) $(GLWD_SRC)/misc.c

%.o: %.c $(GLWD_SRC)/glewlwyd.h
	$(CC) $(CFLAGS) $(CPPFLAGS) $<

libmodmock.so: mock.o misc.o
	$(CC) -shared -Wl,-soname,libmodmock.so mock.o misc.o -o libmodmock.so $(LIBS) $(LDFLAGS)

clean:
	rm -f *.o *.so

debug: ADDITIONALFLAGS=-DDEBUG -g -O0

debug: libmodmock.so $(TARGET)

release: ADDITIONALFLAGS=-O3

release: $(TARGET)

install:
	mkdir -p $(MODULES_TARGET)
	cp -f *.so $(MODULES_TARGET)

=== debian/changelog ===
glewlwyd (2.7.6+ds-3) unstable; urgency=medium

  * Add Catalan translation (Closes: #1104117)
  * Update Brazilian Portuguese translation (Closes: #1103461)

 -- Nicolas Mora <babelouest@debian.org>  Mon, 12 May 2025 16:41:20 -0400

glewlwyd (2.7.6+ds-2) unstable; urgency=medium

  * d/patches: Fix CVE-2024-25715
      possible open redirection via redirect_uri
  * d/control: Use builddep pkgconf instead of pkg-config
  * d/copyright: Update copyright year to 2024

 -- Nicolas Mora <babelouest@debian.org>  Mon, 12 Feb 2024 17:23:41 -0500

glewlwyd (2.7.6+ds-1) unstable; urgency=medium

  * New upstream release
  * Repack source to ignore duplicates (Closes: #1045025)
  * d/rules: Remove configure option -DDOWNLOAD_DEPENDENCIES=OFF
  * d/copyright: Remove ignored files copyright notice
  * d/copyright: Remove CC-BY-3.0 license paragraph
  * d/source: add lintian-override
    package-contains-documentation-outside-usr-share-doc

 -- Nicolas Mora <babelouest@debian.org>  Sat, 18 Nov 2023 19:13:45 -0500

=== debian/control ===
Source: glewlwyd
Section: web
Priority: optional
Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
Uploaders: Thorsten Alteholz <debian@alteholz.de>
         , Nicolas Mora <babelouest@debian.org>
Build-Depends: debhelper-compat (= 13)
# Backend dependencies
             , pkgconf
             , po-debconf
             , libmicrohttpd-dev
             , libjansson-dev
             , libcurl4-gnutls-dev
             , libldap2-dev
             , libsqlite3-dev
             , libconfig-dev
             , libgnutls28-dev
             , liborcania-dev
             , libyder-dev
             , libulfius-dev
             , libhoel-dev
             , librhonabwy-dev
             , libiddawc-dev
             , liboath-dev
             , libcbor-dev
             , cmake
# Front-end dependencies
Build-Depends-Indep: nodejs
             , node-react-dom
             , node-babel7
             , node-babel-loader
             , node-css-loader
             , node-i18next
             , node-i18next-browser-languagedetector
             , node-i18next-http-backend
             , node-qrcode-generator
             , webpack
             , fonts-fork-awesome
             , libjs-jquery
             , libjs-bootstrap4
             , libjs-popper.js
Standards-Version: 4.7.2
Homepage: https://github.com/babelouest/glewlwyd
Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/glewlwyd.git
Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/glewlwyd.git
Rules-Requires-Root: no

Package: glewlwyd
Architecture: any
Depends: ${shlibs:Depends},
       , ${misc:Depends}
       , glewlwyd-common
       , sqlite3
       , ucf
       , dbconfig-mysql | dbconfig-sqlite3 | dbconfig-pgsql | dbconfig-no-thanks
       , adduser
Pre-Depends: ${misc:Pre-Depends}
Suggests: rnbyc
Description: Experimental Single-Sign-On server with multiple factor authentication
 Experimental Single Sign On server, OAuth2, Openid Connect, multiple factor
 authentication with, HOTP/TOTP, FIDO2, TLS Certificates, etc. extensible via
 plugins.
 .
 It's recommended not to use Glewlwyd in production, more likely to test
 OAuth2/OpenID behavior, MFA connections, or IdP in general. You can also
 explore its functionalities and help yourself with its source code for other
 implementations.
 .
 If you intend to use it in production, it's highly recommended to follow the
 documentation and enable only the features you will use.
 Authentication processus supported:
  - OAuth2
  - OpenID Connect
 .
 Allows users to authenticate via multiple factors:
  - Password
  - One-time password (TOTP/HOTP)
  - Webauthn (Yubikey, Android devices)
  - One-time password sent via e-mail
  - TLS Certificate
  - External OAuth2/OIDC providers
 .
 Users and clients can be stored and managed from various backends:
  - Database
  - LDAP service
  - HTTP Backend service providing Basic Authentication
 .
 Allows users to register a new account with the possibility to confirm their
 e-mail address or not. During the registration process, the new user may be
 expected to register their passwords, as well as other authentication factors:
  - One-time password (TOTP/HOTP)
  - Webauthn (Yubikey, Android devices)
  - TLS Certificate
  - External OAuth2/OIDC providers

Package: glewlwyd-common
Depends: ${misc:Depends}
         , fonts-fork-awesome
         , libjs-jquery
         , libjs-bootstrap4
         , libjs-popper.js
Pre-Depends: ${misc:Pre-Depends}
Architecture: all
Multi-Arch: foreign
Description: Experimental Single-Sign-On server - common files
 Experimental Single Sign On server, OAuth2, Openid Connect, multiple factor
 authentication with, HOTP/TOTP, FIDO2, TLS Certificates, etc. extensible via
 plugins.
 .
 It's recommended not to use Glewlwyd in production, more likely to test
 OAuth2/OpenID behavior, MFA connections, or IdP in general. You can also
 explore its functionalities and help yourself with its source code for other
 implementations.
 .
 If you intend to use it in production, it's highly recommended to follow the
 documentation and enable only the features you will use.
 Authentication processus supported:
  - OAuth2
  - OpenID Connect
 .
 Allows users to authenticate via multiple factors:
  - Password
  - One-time password (TOTP/HOTP)
  - Webauthn (Yubikey, Android devices)
  - One-time password sent via e-mail
  - TLS Certificate
  - External OAuth2/OIDC providers
 .
 Users and clients can be stored and managed from various backends:
  - Database
  - LDAP service
  - HTTP Backend service providing Basic Authentication
 .
 Allows users to register a new account with the possibility to confirm their
 e-mail address or not. During the registration process, the new user may be
 expected to register their passwords, as well as other authentication factors:
  - One-time password (TOTP/HOTP)
  - Webauthn (Yubikey, Android devices)
  - TLS Certificate
  - External OAuth2/OIDC providers
 .
 This package contains the architecture independent files.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_BUILD_HARDENING=1

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --buildsystem=cmake --builddirectory=build

override_dh_auto_configure:
	# add a fake empty file in webapp-src/output so dh_install will not fail
	mkdir webapp-src/output/ && touch webapp-src/output/admin.js
	# configure cmake build
	dh_auto_configure -- $(ARGS) \
	                    -DSKIP_BUILD_RPATH=TRUE \
	                    --no-warn-unused-cli

override_dh_auto_build-indep:
	# Build webapp
	(cd webapp-src && webpack --config webpack.config.js)

override_dh_auto_install:
	echo "do nothing here"

override_dh_clean:
	dh_clean --
	rm -rf webapp-src/output

=== debian/watch ===
version=4

# Thanks https://wiki.debian.org/Javascript/Repacking
# https://github.com/babelouest/glewlwyd
opts=\
repacksuffix=+ds,\
repack,compression=xz,\
dversionmangle=auto,\
filenamemangle=s/.*?(\d[\d\.-]*@ARCHIVE_EXT@)/glewlwyd-$1/ \
 https://github.com/babelouest/glewlwyd/tags .*/archive/.*/v?([\d\.]+).tar.gz
